/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package DataLayer;

import org.jetbrains.annotations.NotNull;
import org.json.simple.JSONObject;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.*;
import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * @author install1
 */
public class DataMapper {

    public static ArrayList<String> getAllStrings() {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        ArrayList<String> arrayListStr = new ArrayList();
        Properties prop = new Properties();
        String fileName = "app.config";
        try (FileInputStream fis = new FileInputStream(fileName)) {
            prop.load(fis);
        } catch (FileNotFoundException ex) {
        } catch (IOException ex) {
        }
        try {
            l_cCon = DBCPDataSource.getConnection();
            //not better, just forces the responds to variate a lot more
            String l_sSQL = "SELECT * FROM `Sentences` where last_used < CURRENT_DATE() - INTERVAL "
                    + String.valueOf(prop.getProperty("app.interval_days"))
                    + " DAY order by LENGTH(Strings) desc";
            //System.out.println("l_sSQL: " + l_sSQL);
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next()) {
                arrayListStr.add(l_rsSearch.getString(1));
            }
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return arrayListStr;
    }

    public static void InsertMYSQLStrings(String str) {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        Properties prop = new Properties();
        String fileName = "app.config";
        try (FileInputStream fis = new FileInputStream(fileName)) {
            prop.load(fis);
        } catch (FileNotFoundException ex) {
        } catch (IOException ex) {
        }
        String l_sSQL = "INSERT IGNORE `Sentences` (`Strings`, `last_used`) VALUES (?, DATE(NOW()) - interval " +
                String.valueOf(prop.getProperty("app.interval_days_minus")) + " DAY)";
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_pStatement.setString(1, str);

            l_pStatement.execute();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
    }


    public static void CloseConnections(PreparedStatement ps, ResultSet rs, Connection con) {
        if (rs != null) {
            try {
                rs.close();
            } catch (SQLException ex) {
                Logger.getLogger(DataMapper.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        if (ps != null) {
            try {
                ps.close();
            } catch (SQLException ex) {
                Logger.getLogger(DataMapper.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        if (con != null) {
            try {
                con.close();
            } catch (SQLException ex) {
                Logger.getLogger(DataMapper.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public static void checkStringsToDelete() {
        Properties prop = new Properties();
        String fileName = "app.config";
        try (FileInputStream fis = new FileInputStream(fileName)) {
            prop.load(fis);
        } catch (FileNotFoundException ex) {
        } catch (IOException ex) {
        }
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        String CountSQL = "select count(*) from Sentences";
        String l_sSQL = "delete from Sentences order by last_used asc limit 5;";
        try (Connection l_cCon = DBCPDataSource.getConnection()) {
            l_pStatement = l_cCon.prepareStatement(CountSQL);
            ResultSet resultSet = l_pStatement.executeQuery();
            if (resultSet.next()) {
                int count = resultSet.getInt(1);
                if (count > Integer.valueOf(prop.getProperty("app.string_count"))) {
                    //System.out.println("cleaning strings: " + l_sSQL);
                    l_pStatement = l_cCon.prepareStatement(l_sSQL);
                    l_pStatement.executeUpdate();
                }
            }
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, null);
        }
    }

    public static void updateLastUsed(@NotNull ArrayList<String> mysqlUpdateLastUsed) {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        String l_sSQL = "update Sentences Set last_used = now() where Strings = (?)";
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            for (String str1 : mysqlUpdateLastUsed) {
                l_pStatement.setString(1, str1);
                l_pStatement.execute();
            }
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
    }


    //from here it's testing stuff

    public static void WriteDataToSpecificFunction(Set<JSONObject> dataSet, String testCaseFunction) {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;

        try {
            //generating the columns to be inserted
            StringBuilder l_sSQL_columns = new StringBuilder("insert into `" + testCaseFunction + "` (");
            for (JSONObject data : dataSet) {
                for (Object key : data.keySet()) {
                    //only taking parameters that match the current test type.
                    if (!key.toString().startsWith(testCaseFunction + "Double_param") &&
                            !key.toString().startsWith(testCaseFunction + "_param")) continue;
                    l_sSQL_columns.append(key.toString());
                    l_sSQL_columns.append(",");
                }
                break;
            }
            l_sSQL_columns.setLength(l_sSQL_columns.length() - 1);
            l_sSQL_columns.append(", java_pid) VALUES ");


            l_cCon = DBCPDataSource.getConnection();
            int indexCounter = 0;
            StringBuilder l_sSQL = new StringBuilder(" ");
            //adding the actual value pairs that have to be inserted.
            for (JSONObject data : dataSet) {
                if (indexCounter % 250 == 0 && indexCounter > 0) {
                    System.out.println("insert Traversed " + indexCounter + "/" + dataSet.size());
                    l_sSQL.setLength(l_sSQL.length() - 1); //removing last comma
                    l_pStatement = l_cCon.prepareStatement(l_sSQL_columns.toString() + l_sSQL.toString());
                    l_pStatement.execute();
                    l_sSQL = new StringBuilder(" ");
                }
                indexCounter++;
                l_sSQL.append(" (");

                for (Object key : data.keySet()) {
                    //only taking parameters that match the current test type.
                    if (!key.toString().startsWith(testCaseFunction + "Double_param") &&
                            !key.toString().startsWith(testCaseFunction + "_param")) continue;
                    if (key.toString().startsWith("simpleRNNMaxtrixVectorsDouble") || key.toString().startsWith("simpleRNNMatrixCalculationsDouble")
                            || key.toString().startsWith("typeDependenciesGrammaticalRelationDouble") || key.toString().startsWith("iterateTreesDouble")) {
                        Double doubleValue1 = (Double) data.get(key);
                        l_sSQL.append(doubleValue1);
                    } else {
                        //System.out.println("key: " + key + " val: " + data.get(key));
                        int intValue1 = (int) data.get(key);
                        l_sSQL.append(intValue1);
                    }
                    l_sSQL.append(",");
                }
                l_sSQL.append(ProcessHandle.current().pid());
                l_sSQL.append("),");
            }
            l_sSQL.setLength(l_sSQL.length() - 1); //removing last comma
            l_pStatement = l_cCon.prepareStatement(l_sSQL_columns.toString() + l_sSQL.toString());
            l_pStatement.execute();
            System.out.println("finished last insert traversed");
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
    }



    public static List<testClasses> GetAllTestsCases() {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        List<testClasses> testClassesList = new ArrayList();
        try {
            l_cCon = DBCPDataSource.getConnection();
            String l_sSQL = "select * from `sentence_testing` order by rowid asc";
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next()) {
                testClasses testClass = new testClasses(l_rsSearch.getString(1), l_rsSearch.getString(2), l_rsSearch.getInt(3), l_rsSearch.getString(4),
                        l_rsSearch.getBoolean(5));
                testClassesList.add(testClass);
            }
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return testClassesList;
    }

    public static void MarkSuccessfullFunctionData(String testCaseFunction, Integer rowid) {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            StringBuilder l_sSQL = new StringBuilder("update `" + testCaseFunction + "` set passed_all_test_cases = true  where rowid = " + rowid);
            l_pStatement = l_cCon.prepareStatement(l_sSQL.toString());
            l_pStatement.executeUpdate();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
    }

    public static Set<JSONObject> SelectRandomDataNotProcessed(String testCaseFunction) {
        Set<JSONObject> randomDataSet = new HashSet<>();
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            StringBuilder l_sSQL = new StringBuilder("select * from `" + testCaseFunction + "` where "
            + " java_pid = " + ProcessHandle.current().pid());
            l_pStatement = l_cCon.prepareStatement(l_sSQL.toString());
            l_rsSearch = l_pStatement.executeQuery();
            ResultSetMetaData metaData = l_rsSearch.getMetaData();
            while (l_rsSearch.next()) {
                JSONObject object = new JSONObject();
                for (int i = 1; i <= metaData.getColumnCount(); i++) //these indexes start at 1 instead of 0
                {
                    if (metaData.getColumnName(i).equals("created_on")) break;
                    int columnType = metaData.getColumnType(i);
                    Object Value = null;
                    if (Types.INTEGER == columnType) {
                        Value = l_rsSearch.getInt(i);
                    } else if (Types.DECIMAL == columnType) {
                        Value = l_rsSearch.getDouble(i);
                    } else continue;
                    object.put(metaData.getColumnName(i), Value);
                }
                randomDataSet.add(object);
            }
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return randomDataSet;
    }

    public static List<testClasses> GetFunctionTestCases() {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        List<testClasses> testClassesList = new ArrayList();
        try {
            l_cCon = DBCPDataSource.getConnection();
            String l_sSQL = "select * from `sentence_testing_function` order by rowid asc";
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next()) {
                testClasses testClass = new testClasses(l_rsSearch.getString(1), l_rsSearch.getString(2), l_rsSearch.getInt(3), l_rsSearch.getString(4),
                        false);
                testClassesList.add(testClass);
            }
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return testClassesList;
    }

    public static void UpdateProcessed(String testCaseFunction, Set<JSONObject> randomDataSet, int max_index_counter_tests_passed, Double bestScore,
                                       String comperator_for_score_for_failing_testcase) {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        List<testClasses> testClassesList = new ArrayList();
        boolean maxIndexCounterTestsPassedCount = DataMapper.getMaxIndex_counter_tests_passedCount(max_index_counter_tests_passed, testCaseFunction);

        try {
            l_cCon = DBCPDataSource.getConnection();
            for (JSONObject dataRandom : randomDataSet) {
                Double failed_score = (Double) dataRandom.get("failed_testcase_score");
                System.out.println("failed_score: " + failed_score + " max_index_counter_tests_passed: " + max_index_counter_tests_passed);
                //updating rows that reached better test
                if ((int)dataRandom.get("index_counter_tests_passed") > max_index_counter_tests_passed) {
                    String l_sSQL = "update `" + testCaseFunction + "` set index_counter_tests_passed = " + dataRandom.get("index_counter_tests_passed") +
                            " , failed_testcase_score =  " + dataRandom.get("failed_testcase_score") +
                            " , java_pid = NULL " +
                            " where rowid = " + dataRandom.get("rowid");
                    l_pStatement = l_cCon.prepareStatement(l_sSQL);
                    l_pStatement.executeUpdate();
                }
                //add the result if its better than the last.
                else if ((int) dataRandom.get("index_counter_tests_passed") == max_index_counter_tests_passed
                        && comperator_for_score_for_failing_testcase.contains(">") ?
                                failed_score > bestScore :
                                failed_score < bestScore) {
                    String l_sSQL = "update `" + testCaseFunction + "` set index_counter_tests_passed = " + dataRandom.get("index_counter_tests_passed") +
                            " , failed_testcase_score =  " + dataRandom.get("failed_testcase_score") +
                            " , java_pid = NULL " +
                            " where rowid = " + dataRandom.get("rowid");
                    l_pStatement = l_cCon.prepareStatement(l_sSQL);
                    l_pStatement.executeUpdate();
                }
                else //deleting rows that gave a worse result.
                {
                    String l_sSQL = "delete from `" + testCaseFunction + "` where rowid = " + dataRandom.get("rowid");
                    l_pStatement = l_cCon.prepareStatement(l_sSQL);
                    l_pStatement.executeUpdate();
                }
            }
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
    }

    public static int get_index_counter_tests_passed(String testCaseFunction, int manualInt)
    {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        int max_index_counter_tests_passed = -1;
        try {
            l_cCon = DBCPDataSource.getConnection();
            String l_sSQL = "select COALESCE(max(index_counter_tests_passed), 0) from `" + testCaseFunction + "`";
            if (manualInt != 0)
            {
                l_sSQL += "WHERE index_counter_tests_passed < " + manualInt;
            }
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_rsSearch = l_pStatement.executeQuery();
            l_rsSearch.next();
            max_index_counter_tests_passed = l_rsSearch.getInt(1);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return max_index_counter_tests_passed;
    }

    public static Set<JSONObject> pickHighestProgression(String testCaseFunction) {
        Set<JSONObject> randomDataSetToReturn = new HashSet<>();
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            String CheckIfAnyRows = "select count(*) from `" + testCaseFunction + "`"; //do we have any rows at all?
            l_pStatement = l_cCon.prepareStatement(CheckIfAnyRows);
            l_rsSearch = l_pStatement.executeQuery();
            if (l_rsSearch.next()){
                int rowcount = l_rsSearch.getInt(1);
                if (rowcount == 0) {
                    return randomDataSetToReturn; // we did not generate anything yet for this category. so start with random data instead.
                }
            }
            int limit = 2;
            int index_counter_tests_passed = 0;
            int attempts = 0;
            while (randomDataSetToReturn.size() < limit && attempts < 5)
            {
                attempts++;
                //select here max(index_counter_tests_passed) then pick the comparator from ArtificialAutism.sentence_testing_function
                //to know if the score has to aim for lowest or highest on the currently failing test case.
                index_counter_tests_passed = get_index_counter_tests_passed(testCaseFunction, index_counter_tests_passed);
                String comperator_for_score_for_failing_testcase = getMaxIndexComparator(index_counter_tests_passed);

                String l_sSQL = "select e1.* from `" + testCaseFunction + "` e1 " +
                        "inner join  " +
                        "(select rowid " +
                        "from `" + testCaseFunction + "` " +
                        "where index_counter_tests_passed = " + index_counter_tests_passed +
                        " and failed_testcase_score is not null " +
                        " group by failed_testcase_score " +
                        "order by failed_testcase_score ";
                if (comperator_for_score_for_failing_testcase.contains(">")) {
                    l_sSQL += "desc";
                } else {
                    l_sSQL += "asc";
                }

                l_sSQL += " ) as e2 on e1.rowid = e2.rowid";

                l_pStatement = l_cCon.prepareStatement(l_sSQL);
                l_rsSearch = l_pStatement.executeQuery();
                ResultSetMetaData metaData = l_rsSearch.getMetaData();

                JSONObject previousObject = null;
                while (l_rsSearch.next()) {
                    JSONObject object = new JSONObject();
                    for (int i = 1; i <= metaData.getColumnCount(); i++) //these indexes start at 1 instead of 0
                    {
                        //if (metaData.getColumnName(i).equals("created_on")) break;
                        int columnType = metaData.getColumnType(i);
                        Object Value = null;
                        if (Types.INTEGER == columnType) {
                            Value = l_rsSearch.getInt(i);
                        } else if (Types.DECIMAL == columnType || Types.DOUBLE == columnType) {
                            Value = l_rsSearch.getDouble(i);
                        } else continue;
                        object.put(metaData.getColumnName(i), Value);
                    }
                    if (previousObject == null)
                    {
                        randomDataSetToReturn.add(object);
                        previousObject = (JSONObject) object.clone();
                    }
                    else
                    {
                        int minimumDifference = 200;
                        Double test = (Double) object.get("failed_testcase_score") - (Double) previousObject.get("failed_testcase_score");
                        if (test > minimumDifference || test < (minimumDifference * -1)) {
                            randomDataSetToReturn.add(object);
                            previousObject = object;
                        }
                    }
                    if (randomDataSetToReturn.size() >= limit)
                    {
                        break;
                    }
                }
            }
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        //create here out of it only unique objects still, so not that many repeating rows.
        for (JSONObject obj : randomDataSetToReturn){
            obj.remove("failed_testcase_score");
        }
        return randomDataSetToReturn;
    }

    public static boolean getMaxIndex_counter_tests_passedCount(int max_index_counter_tests_passed, String testCaseFunction){
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        int index_count_rows_counted = -1;
        try {
            l_cCon = DBCPDataSource.getConnection();
            String l_sSQL = "select count(*) from `" + testCaseFunction + "` " +
                    " where index_counter_tests_passed = " + max_index_counter_tests_passed;
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_rsSearch = l_pStatement.executeQuery();
            l_rsSearch.next();
            index_count_rows_counted = l_rsSearch.getInt(1);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return index_count_rows_counted < 1000;

    }

    public static String getMaxIndexComparator(int max_index){
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        String comperator_for_score_for_failing_testcase = "";
        try {
            l_cCon = DBCPDataSource.getConnection();
            String l_sSQL = "select comperator_for_score " +
                    "from ArtificialAutism.sentence_testing_function stf " +
                    "order by rowid asc limit 1 OFFSET " + max_index;
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_rsSearch = l_pStatement.executeQuery();
            l_rsSearch.next();
            comperator_for_score_for_failing_testcase = l_rsSearch.getString(1);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return comperator_for_score_for_failing_testcase;
    }

    public static HashMap<Integer, ArrayList<Integer>> get_parameter_generations(Set<JSONObject> randomDataSet, String testCaseFunction) {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        HashMap<Integer, ArrayList<Integer>> arr = new HashMap<Integer, ArrayList<Integer>>(); //key rowid, value is arraylist of modified params.
        try {
            l_cCon = DBCPDataSource.getConnection();
            for (JSONObject jobject : randomDataSet)
            {
                int rowid = (int) jobject.get("rowid");
                String l_sSQL = "select params_tried from " +
                        " ArtificialAutism.parameters_generation " +
                        " where rowid_function_ref = '" + rowid + "' " +
                        " and function_ref = ' " + testCaseFunction + "'";
                l_pStatement = l_cCon.prepareStatement(l_sSQL);
                l_rsSearch = l_pStatement.executeQuery();
                if (l_rsSearch.next())
                {
                    //found existing row, reading params_tried.
                    String params_tried = l_rsSearch.getString(1);
                    String[] split = params_tried.split(",");
                    ArrayList<Integer> integers = new ArrayList<>();
                    for (String number : split) {
                        if (!number.isBlank()) {
                            integers.add(Integer.parseInt(number));
                        }
                    }
                    arr.put(rowid, integers);
                }
                else
                {
                    //insert new row
                    l_sSQL = "insert into ArtificialAutism.parameters_generation (rowid_function_ref, params_tried, function_ref) " +
                            " values (' " + rowid + "', '', ' " + testCaseFunction + "')";
                    l_pStatement = l_cCon.prepareStatement(l_sSQL);
                    l_pStatement.executeUpdate();
                    arr.put(rowid, new ArrayList<Integer>());
                }

            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return arr;
    }

    public static void deleteRow(int rowid, String testCaseFunction) {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            String l_sSQL = "delete from `" + testCaseFunction + "` where rowid = " + rowid;
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_pStatement.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
    }

    public static Double getbestScoreFormax_index_counter_tests_passed(int maxIndexCounterTestsPassed, String testCaseFunction, String comperator_for_score_for_failing_testcase) {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        Double bestScores = 0.0;
        try {
            l_cCon = DBCPDataSource.getConnection();
            String l_sSQL = "select failed_testcase_score from `" + testCaseFunction + "` " +
                    "where index_counter_tests_passed = " + maxIndexCounterTestsPassed + " " +
                    "order by failed_testcase_score ";

            if (comperator_for_score_for_failing_testcase.contains(">")) {
                l_sSQL += "desc";
            } else {
                l_sSQL += "asc";
            }
            l_sSQL += " limit 1";
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_rsSearch = l_pStatement.executeQuery();
            l_rsSearch.next();
            bestScores = l_rsSearch.getDouble(1);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return bestScores;
    }

    public static void UpdateModifiedKeyForRowID(Set<JSONObject> randomDataSet, String testCaseFunction) {
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;

        HashMap<Integer, ArrayList<Integer>> arr = get_parameter_generations(randomDataSet, testCaseFunction);
        try {
            l_cCon = DBCPDataSource.getConnection();
            for (JSONObject jobject : randomDataSet) {
                int rowid = (int) jobject.get("rowid");
                ArrayList<Integer> integers = arr.get(rowid);

                String l_sSQL = " UPDATE ArtificialAutism.parameters_generation " +
                        " set params_tried = '";
                for (int triedParamter : integers){
                    l_sSQL += triedParamter + ",";
                }
                l_sSQL = l_sSQL.substring(0, l_sSQL.length() - 1); //remove trailing comma.

                l_sSQL += "' where rowid_function_ref = " + rowid +
                        " and function_ref = `" + testCaseFunction + "`";
                l_pStatement = l_cCon.prepareStatement(l_sSQL);
                System.out.println("l_sSQL: " + l_sSQL);
                l_pStatement.executeUpdate();
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
    }
}
